\section{GEM with meshless interface tracking (MIT) on \h-refined scattered nodes}
\label{sec:sharp}
Using the meshless principle for the solution of the GEM opens a variety of possibilities for spatial discretization.
%MZ One is to maintain the grain envelope populated with nodes ($\Gamma_\mathrm{e}$) throughout the simulation, which effectively means that instead of reconstructing the envelope from evolving continuous indicator field, the envelope is described by a set of nodes, in our case boundary nodes, as the envelope defines the internal part of the domain (Figure~\ref{fig:domain_discretization}). We call this a sharp-interface (SI) approach.   
We propose a method that considers the grain envelope as a boundary ($\Gamma_\mathrm{e}$) of the liquid domain ($\Omega$), as schematically shown in Figure~\ref{fig:domain_discretization}. The method adapts the node distribution to ensure that the envelope boundary is densely populated with nodes throughout the simulation. These nodes are then also used for the tracking of the envelope. This effectively means that the grain envelope is described as a sharp interface by a set of discretization nodes -- in this case, the boundary nodes from $\Gamma_\mathrm{e} \subset \partial \Omega$. The internal part of the domain is then the liquid surrounding the grain, i.e., the area between the envelope and the outer liquid boundary, $\Gamma_\ell \subset \partial \Omega$ (see Figure~\ref{fig:domain_discretization} for clarity). Equation~\eqref{eq:diffusion} is solved in the domain.
%We refer to this approach as the sharp-interface (SI) approach.
%level set indicator field, which we can avoid using meshless method.  i.e. the envelope is not reconstructed from the evolving continuous indicator, but it is the boundary of the domain.    
%In the context of sharp-interface tracking methods, the dendrite envelope is defined at any time during the simulation by a set of discretization nodes $\Gamma_\mathrm{e}$ positioned at the solidification front as shown in FIgure~\ref{fig:domain_discretization}. 
%It is our assumption that the numerical artefacts appearing in the diffuse-interface capturing methods, are completely avoided when the envelope shape is sought. 
We use scattered nodes to discretize the domain $\Omega$, which allows us to refine the local field description in the vicinity of the grain envelope and consequently improve its discretization quality. Moreover, since the interpolation of scattered data is the backbone of meshless methods, the sampling of the concentration $u_\delta$ (needed to determine the envelope velocity) is inherently present in the solution procedure. This ensures that the error of the sampling is in the worst case of the same order of magnitude as the error of the discretization of the partial differential operators used in solving Equation~(\ref{eq:diffusion})~\cite{le2023guidelines,tominec2021least}. On a theoretical level, the MIT approach should allow us to mitigate some of the problems that are inherently present in PFIC approach (see Section~\ref{sec:diffuse}), but at the cost of a higher computational complexity per node, associated with the use of meshless methods~\cite{jancic_monomial_2021}.

The proposed MIT solution procedure for the GEM starts by building the initial domain -- the initial grain envelope, $\Gamma_\mathrm{e}$, as a circle with radius $r_0$ and the outer liquid boundary, $\Gamma_\ell$ as a square box with side length $L$. The domain and the boundaries are populated with nodes and the initial solute concentration is set to $u_0$ in $\Omega$ and $\Gamma_\ell$ (liquid) and to $0$ in $\Gamma_\mathrm{e}$ (envelope). Afterwards, the explicit forward time marching starts to simulate the solute diffusion and the spatial expansion of the envelope. The entire MIT solution procedure is given in Algorithm~\ref{alg:simulate} and its elements are explained in more detail in the following subsections.

\begin{algorithm}[h]
    \caption{MIT solution procedure for simulation of dendritic grain growth.}
    \label{alg:simulate}
    \vspace{1mm}
    \textbf{Input:} GEM, nodal density function $h:~\Omega\to \R$, RBF-FD approximation basis $\xi$, boundary concentration $u_0$, number of time steps $I_{\text{max}}$, list of cumulative boundary node displacements $\varphi$, time step $\mathrm{d}t$, parametric spline degree $k$.\\
    \textbf{Output:} Concentration field $u$ and domain discretization $\Omega$. \\

    \begin{algorithmic}[1]
        \State $\Omega, u \gets \Call{initialize}{h, u_0}$
        \Comment{Obtain initial domain $\Omega$ and initial concentration field $u$.}
        \State $\Gamma_{e} \gets \Call{get\_envelope}{\Omega}$
        \Comment{Obtain envelope boundary nodes.}
        \State $\varphi \gets \b 0$
        \Comment{Initialize cumulative displacements of grain envelope nodes.}\\

        \Function{simulate\_growth}{GEM, $\Omega, h, \xi, \varphi, u, \mathrm{d}t$}
        \For{$i$}{0}{$I_{\text{max}}$} \label{alg:while}
        \State $\L \gets \Call{operator\_approximation}{\text{GEM}, \Omega, \xi}$
        \Comment{Approximation of differential operators.}
        \State $u \gets \Call{solve\_diffusion}{\Omega, \L, \mathrm{d}t}$\label{alg:line_diffusion}
        \Comment{Solute diffusion problem.}
        \State $\Gamma_\mathrm{e}^\star \gets \Call{new\_envelope}{\text{GEM}, \Omega, \Gamma_\mathrm{e}, u,\xi, \mathrm{d}t}$ \label{alg:new_envelope}
        \Comment{Obtain new envelope nodes positions as defined by GEM.}
        \\
        \If{$\Call{max\_tip}{\Gamma_\mathrm{e}^\star} >  \Call{max\_tip\_allowed}{}$}
        \State \Return $u, \Omega$
        \Comment{End simulation.}
        \EndIf
        \\
        \State $\varphi \gets \Call{add\_displacements}{\Gamma_\mathrm{e}, \Gamma_\mathrm{e}^\star, \varphi}$
        \Comment{Obtain list of updated total displacement magnitudes.}

        \If{$\Call{max}{\varphi} > \he / 2$}\label{alg:disp}
        \State $\Omega^\star \gets \Call{re-discretize\_domain}{\Gamma_\mathrm{e}^\star, h, k}$\label{alg:re-discretize}
        \Comment{Construct new domain $\Omega$ using envelope nodes $\Gamma_\mathrm{e}^\star$.}
        \State $u \gets \Call{map\_concentration}{\Gamma, \Omega^\star, u, \xi}$ \label{alg:map}
        \Comment{Map concentration field to new discretization $\Omega^\star$.}
        \State $\Gamma_{e} \gets \Call{envelope\_boundary}{\Omega}$
        \Comment{Obtain envelope boundary nodes.}
        \State $\Omega \gets \Omega^\star$
        \Comment{Re-assign domain.}
        \State $\varphi \gets \b 0$
        \Comment{Reset cumulative displacements of grain envelope nodes.}
        \Else
        \State $\Omega, u \gets \Call{remove\_nodes}{h, \Omega}$
        \Comment{Remove nodes from $\Omega$ and $u$ closer to envelope than $(0.8 \he)^2$.}
        \EndIf

        \EndFor \\
        \State \Return $u, \Omega$
        \EndFunction
    \end{algorithmic}
\end{algorithm}
%
%
\subsection{Domain discretization}
\label{sec:discretization}
% \mz{Tale odstavek spodaj sem malo poenostavil. Izvirno verzijo sem bolj težko razumel, zato sem preformuliral in tudi izpustil nekaj podrobnosti, ki se mi ne zdijo bistvene. Detajli o algoritmu so itak v paperju Slak\&Kosec, 2019.}
To discretize the domain $\Omega$ with scattered nodes, we employ a dedicated dimension-independent variable density meshless node positioning (DIVG) algorithm~\cite{slak2019generation}. DIVG is an iterative algorithm that populates the entire domain in an advancing front manner, starting from one or more initial seed nodes stored in the \emph{expansion queue}. By default, the algorithm uses all boundary nodes, i.e.\ nodes from $\Gamma_\mathrm{e}$ and $\Gamma_\ell$, as seed nodes. In each iteration, a single node $\b{x}_i$ is removed from the queue and is \emph{expanded}. Expansion means that candidates for new nodes are uniformly positioned on
%the annulus with inner radius $h_i(\b{x}_i)$ and outer radius $h_o(\b{x}_i)$ centred at $\b{x}_i$. Note that the difference between inner and outer radius is relatively small allowing to safely assume $h_i(\b{x}_i)=h_o(\b{x}_i)=h(\b{x}_i)$ for further discussion. 
a circle with radius $h(\b{x}_i)$, then those that fall outside the domain (we discuss the \texttt{inside check} in Section~\ref{sec:reconstruction}) or lie too close to the already accepted nodes, are discarded. The remaining candidates are accepted, i.e., they are added to the domain and to the expansion queue. The iterative procedure continues until no new nodes can be added to the domain and the expansion queue is empty.

A detailed description of the DIVG algorithm can be found in~\cite{slak2019generation}. The key feature of DIVG is its ability to populate the domain with a spatially variable node spacing, $h(\b{x})$, and that it can populate complex geometries regardless of the dimensionality of the domain~\cite{depolli_parallel_2022, de2019fast}. An example of nodes generated with DIVG within $\Omega$ and for its Dirichlet (envelope $\Gamma_\mathrm{e}$) and Neumann (liquid $\Gamma_\ell$) boundaries is shown in Figure~\ref{fig:domain_discretization}.

\begin{figure}
    \centering
    \includegraphics[width=0.5\textwidth]{figures/domain_discretization.eps}
    \caption{Example \h-refined domain discretization. Additionally, example stencils on Dirichlet (green), Neumann (red) boundary and in the interior (blue) are shown.}
    \label{fig:domain_discretization}
\end{figure}

To ensure an accurate description of the grain envelope and of the steep diffusion field in the vicinity of the envelope we employ \h-refinement through the following internodal distance function
\begin{equation}
    \label{eq:slakNodes}
    h(\x) = \begin{cases}
        \he                                                      & , \text{ if } \x \in \Gamma_\mathrm{e} \\
        h_\ell                                                   & , \text{ if } \x \in \Gamma_\ell       \\
        \he + (h_\ell - \he)  \frac{ d(\x)}{ d_\mathrm{closest}} & , \text{ otherwise}
    \end{cases},
\end{equation}
where $\he$ and $h_\ell$ are the internodal distances on the grain envelope and the outer liquid boundary, $d(\x)$ is the Euclidean distance between $\x$ and the nearest node on the envelope, and $d_\text{closest}$ is the Euclidean distance between the node on the envelope boundary, $\Gamma_\mathrm{e}$, nearest to $\x$ and the node on the outer liquid boundary, $\Gamma_\ell$, nearest to $\x$. In our case, $\he < h_\ell$. Such definition of $h(\x)$ gives a linearly decreasing internodal distance towards the envelope, as shown in Figure~\ref{fig:domain_discretization} with green coloured nodes on an illustrative dendrite-like shape.

%
%
%\subsubsection*{Criterion for domain re-discretization}
\subsection{Criterion for domain re-discretization}
With the growth of the grain the envelope boundary moves and the shape and size of the domain therefore evolves. The spatial discretization must therefore be adapted with time. Besides the approximation of the differential operators, the domain discretization is among the most computationally demanding parts of Algorithm~\ref{alg:simulate}. Since the displacements of the envelope nodes within a single time step are typically small (much smaller than the local internodal distance $\he$) and since RBF-FD is relatively robust to non-optimal nodal positions~\cite{jancic-stability,le2023guidelines}, it is not necessary to regenerate the discretization of the computational domain at each time step. Instead, we use a criterion based on the cumulative displacement magnitudes for each node $\x\env$ on the envelope.
The cumulative displacement magnitudes are collected in an array-like data type $\varphi$, which essentially holds information about the total displacement magnitude of all envelope nodes since the last domain re-discretization.

Based on the maximum cumulative displacement among all nodes, $\max(\varphi)$, we then distinguish between two possible cases (see line~\ref{alg:disp} in Algorithm~\ref{alg:simulate}):
\begin{description}
    \item[$\max(\varphi) < \he /2:$] The largest cumulative displacement of the envelope node is smaller than half of the local internodal distance on the envelope, $\he$. Note that $h_\mathrm{e}$ is a parameter of the method and is constant. In this case re-discretization of the computational domain is not yet necessary. The envelope nodes are repositioned from $\Gamma_\mathrm{e}$ to $\Gamma_\mathrm{e}^\star$, according to the GEM. To avoid that computational nodes from the interior of the domain are too close to or inside\footnote{A detailed description of the decision-making algorithm weather a given node is inside the envelope or not is provided in Section~\ref{sec:reconstruction}.} the recomputed grain envelope (as this may affect the stability of the RBF-FD approximation), all nodes that fall inside the new envelope $\Gamma_\mathrm{e}^\star$ or are closer than $0.8\he$ to the envelope are removed from the domain $\Omega$.

    \item[$\max(\varphi) \geq \he/2:$] The largest cumulative displacement is larger or equal to half of the local internodal distance $\he$. In this case a complete re-discretization of the computational domain is required. The algorithm for re-discretization is given in Algorithm~\ref{alg:reconstruction} in line~\ref{alg:rediscretize} and gives the new computational nodes. The corresponding concentration field is obtained by mapping (interpolating) the field from the old to the new discretization (Algorithm~\ref{alg:simulate}, line~\ref{alg:map}). The interpolation method is discussed in detail in Section~\ref{sec:pu}.
\end{description}

%Note that whether the re-discretization is required or not is based on the internodal distance $\he$ on the dendritic envelope. While this value could be optimized to increase the computational efficiency even further, it must be noted that the larger the threshold value the larger can be the distortions of the envelope shape. Our observations showed that $\he/2$ is a good value to improve the computational efficiency of the solution procedure with minimal re-construction distortions introduced.
%
%

\subsection{Meshless approximation of differential operators}
\label{sec:approx}
The next step is the discretization of partial differential operators $\L$, in our case $\lap$ and $\nabla$, which appear in Equation~\eqref{eq:diffusion} and on the Neumann boundary, respectively. For each computational node $\x_i$ in the domain, a set of nearby nodes $\mathcal N_i = \left \{ \x_j \right \}_{j=1}^n$, commonly called \emph{stencil} or \emph{support} nodes, is defined. While special stencil node selection algorithms showed promising results~\cite{davydov2022improved,9803651}, we use the simplest approach and choose the closest $n$ nodes according to the Euclidean distance, obtained efficiently by constructing a $k$-d tree. Example stencils in the interior of the domain and on the Dirichlet and Neumann boundaries are shown in Figure~\ref{fig:domain_discretization}.

Once the stencil is defined, a linear differential operator $\L$ in node $\x_c$ is approximated over a set of $n$ stencil nodes $\mathcal N_c$ with
\begin{equation}
    \label{eq:ansatz}
    \L \big (u(\x_c)\big ) \approx \sum_{j=1}^nw_ju(\x_j),
\end{equation}
for stencil nodes $\x_j\in \mathcal{N}_c$, function $u$ and weights $\w$. The weights are obtained by solving a linear system, assembled from the chosen set of basis functions.

In this work, we use polyharmonic splines (PHS)~\cite{bayona2017role} augmented with $N_p=\binom{m+d}{m}$ monomials up to order $m$ in the $d=2$ dimensional domain $\Omega$.

This corresponds to a commonly used meshless method, also referred to as the RBF-FD approximation~\cite{tolstykh2003using,flyer2016role,bayona2017role}.

By enforcing the equality of Equation~\eqref{eq:ansatz} for the approximation basis, we can write a linear system
\begin{equation}
    \label{eq:rbf-system-aug}
    \underbrace{\begin{bmatrix}\b \Phi & \b P \\\b P^\T & \b 0\end{bmatrix}}_{\b A} \begin{bmatrix} \b w \\ \b \lambda \end{bmatrix} = \begin{bmatrix} \b\ell_\phi \\ \b\ell_p \end{bmatrix},
\end{equation}
with matrix $\b P \in \R^{n\times N_p}$ of the evaluated monomials, matrix $\b \Phi \in \R^{n\times n}$ of the evaluated RBFs and $\b \ell_\phi$ and $\b \ell_p$ are vectors of values assembled by applying the considered operator $\L$ to the RBFs and monomials respectively. To obtain the weights $\w$, the system is solved and Lagrangian multipliers $\b \lambda$ are discarded.

\hl{Note that the conditionally positive definite RBFs alone do not ensure the positive definiteness of matrices $\b A$. The interpolation problem becomes positive definite Afterwards monomials are added to the approximation basis}~\cite{bayona2017role}\hl{. Another consequence of adding monomials to the approximation basis is the achieved consistency up to a certain order.} Moreover, we follow the recommendations of Bayona~\cite{bayona2019insight} and define the stencil size $n$ as
\begin{equation}
    n = 2 N_p =2 \binom{m + d}{m}
    \label{eq:stencil_size}
\end{equation}
to ensure a stable approximation.

The approximation~\eqref{eq:ansatz} also holds for $\L \coloneqq 1$, effectively allowing us to use the same formulation for the approximation of field values at locations that do not correspond to the discretization points. This property will be used in Section~\ref{sec:pu}, where we seek an accurate interpolation of the concentration field at the stagnant-film positions $\x^\delta$.

Note that the formulation of RBF-FD allows us to control the order of the interpolation through the order of the augmenting monomials~\cite{jancic_monomial_2021, bayona2017role}. In this study, we will experiment with the second ($m=2$) and fourth ($m=4$) orders.
%
%

%\subsection{The moving boundary problem -- modifying the dendrite envelope positions}
\subsection{Propagation of the envelope -- moving the boundary}
\label{sec:growth}
At each time step, the new solute concentration field, $u$, is obtained by discretizing the diffusion Equation~\eqref{eq:diffusion} with the meshless approximation and solving it explicitly using the forward Euler time-marching scheme (see line~\ref{alg:line_diffusion} of Algorithm~\ref{alg:simulate}). With the known concentration field, the envelope velocities are calculated by the GEM and the grain envelope is then propagated (line~\ref{alg:new_envelope} of Algorithm~\ref{alg:simulate}). Recall that the envelope speed depends on the concentration $u_\delta$ at the stagnant-film and on the direction of the envelope normal (see Equations~(\ref{eq:envelopespeed}--\ref{eq:tipspeed})).
%As a result, the GEM model returns the tip speed, $v$, for each envelope node, $\b x\ienv$, and the considered envelope node is moved to a new position, $\x'\ienv$,
Accordingly, each envelope node, $\b x\ienv$, is propagated to a new position, $\x'\ienv$, by
\begin{equation}
    \label{eq:displacement}
    \x'\ienv = \x\ienv + \cos (\vartheta_i) \, v(u_{\delta,i}) \, \b n_i \, \mathrm{d}t \,,
    \quad \forall \x\ienv \in \Gamma_\mathrm{e},
\end{equation}
where the speed $v$ is given by the GEM model (Equations~(\ref{eq:cantorvogel}--\ref{eq:tipspeed})) as a function of $u_{\delta,i}$, which is the concentration at $\b x_{\delta,i} = \x\ienv + \delta \, \b n_i$ and $\vartheta _i$ is the minimum angle between the envelope normal $\b n _i$ and the 4 unit directional vectors, i.e., $\pm \b {\widehat e}_x$ and $\pm\b{\widehat e} _y$.

It follows that the numerical error in the shape of the grain envelope depends on the accuracy of the evaluation of the stagnant-film concentration, $u_\delta$, and of the normal direction, $\b n_i$. These error sources are studied in the following subsections. $u_\delta$ is calculated by interpolation of the concentration field; the accuracy of different interpolation methods is discussed in Section~\ref{sec:pu}. The normal, $\b n$, is calculated from a parametric reconstruction of the envelope with splines. The same reconstruction is also used for the discretization of the envelope and allows us to ensure quasi-uniform internodal distances on the envelope and consequently to generate a robust spatial discretization of the domain. The envelope reconstruction is discussed in Section~\ref{sec:reconstruction} along with the influence of the spline degree, a key parameter of the reconstruction.
%

\subsubsection{Interpolation of the solute concentration field}
\label{sec:pu}
%In GEM, the envelope velocity $v_n$ is strongly dependant on the solute concentration $u_\delta$ at the stagnant-film around the envelope. 
In the GEM, the stagnant-film concentration, $u_\delta$, is required at any position $\b x^\delta = \x\env +\delta \b n$ within the domain space $\Omega$. Since the concentration is only given at the discretization points $\b x_i\in \Omega$, a suitable interpolation is required. We consider the following three interpolation methods:
\begin{description}
    \item[Shepard's interpolation,] also known as inverse distance weighing, where the interpolant is a weighted average over the neighborhood,

        i.e., the $n$ points closest to $\b x^\delta$, defined as
        \begin{equation}
            \label{eq:shep}
            u(\b x^\delta ) =
            \begin{cases}
                \dfrac{\sum_{i=1}^n\omega_i(\b x^\delta)u(\x_i)}{\sum_{i=1}^n\omega_i(\b x^\delta)} & ,\text{ if } d(\x, \x_i) \neq 0 \text{ for all } i \\
                u (\x_i)                                                                            & ,\text{ if } d(\x, \x_i) = 0 \text{ for some } i
            \end{cases},
        \end{equation}
        for weights $\omega_i(\b x^\delta) = \left \| \b x^\delta - \x_i \right \| ^{-\alpha}$ with power parameter $\alpha = 2$.
    \item[The RBF-FD interpolation,] which uses the RBF-FD approximation described in Section~\ref{sec:approx} to build a local interpolant $F_i(\x^\delta)$ over stencil nodes $\mathcal N (\x^\delta)$ to obtain a local interpolation of the concentration in $\b x^\delta$ for a chosen approximation basis.
    \item [The partition-of-unity (PU) interpolation,] which uses local RBF-FD interpolants and additionally constructs a global representation of the concentration field by employing the PU interpolation~\cite{pu-interpolation,DEMARCHI2019331}. Essentially, the PU approach builds local interpolants $F_i$ over stencil nodes $\mathcal N_i$ for all $N$ discretization nodes $\x_i \in \Omega$. The global interpolant is then constructed as
          \begin{equation}
              F(\x) = \sum_{i=1}^Nw_i(\x)F_i(\x),
          \end{equation} using compactly supported weights $w_i$ that form a partition-of-unity, $\sum_{i=1}^Nw_i(\x)=1$, for all $\x \in \Omega$. The most efficient way to construct the weights is to use the Shepard's construction (see Equation~\ref{eq:shep}) thus
          \begin{equation}
              w_i(\x) = \frac{\omega(\left \| \x - \x_i \right \| /r_i)}{\sum_{j=1}^N\omega(\left \| \x - \x_j \right \| / r_j)},
          \end{equation}
          where $r$ determines the effective radius of the individual interpolants $F$ -- the larger the radius, the more pronounced the averaging effect. Such a construction effectively leads to a weighted average of the local interpolants $F_i$, where $\left \| \x_i - \x \right \| < r_i$, otherwise the weight is 0.

\end{description}
% \subsubsection*{Performance analysis of the proposed interpolation approaches}
To evaluate the performance of the proposed interpolation methods, all three are further discussed and compared in terms of computational complexity and interpolation accuracy.

\begin{itemize}
    \item \emph{Computational complexity} \newline
          The computational complexity of the three interpolation methods is anything but equivalent. Common to all is the construction of a $k$-d tree that allows us to query the nearest $n$ neighbours. Constructing such a structure for a domain with $N$ nodes requires $\mathcal{O}(N\log N)$ operations, while searching for $n$ nearest neighbours requires $\mathcal{O}(n\log N)$ operations.

          The evaluation of Shepard's interpolant then requires additional $\mathcal{O}(n)$ operations. The construction of the RBF-FD interpolant requires $\mathcal{O}(n^3)$ operations to solve the dense linear interpolation system from Equation~\eqref{eq:rbf-system-aug} and additional $\mathcal{O}(n)$ operations to evaluate. The computational complexity of PU is generally higher than that of RBF-FD. In the worst case, i.e., with uniformly distributed nodes and a single query point, the construction of the PU interpolant requires $\mathcal{O}(n(n^3 + n))$ operations. The first term comes from the construction of the RBF-FD interpolant and the second term comes from the calculation of Shepard's weights. To evaluate the PU interpolant, further $\mathcal{O}(n)$ operations are required.

          Thus, the construction of the PU interpolant is the most computationally expensive, followed by the RBF-FD approximant and finally Shepard's interpolant as the cheapest of the three.
          %
    \item \emph{Interpolation accuracy} \newline
          The accuracy of each interpolation approach is evaluated using a two-dimensional Sibson's function
          \begin{equation}
              f(\b x) = f(x,y) =\cos(4\pi \sqrt{(x-1/4)^2 + (y -1/4)^2})
          \end{equation}
          for the domain space $\b x \in [0,1]^2$. We generate $N_{\mathrm{fit}}$ uniformly scattered fit points on which we construct the three proposed interpolation methods and we evaluate the accuracy of the interpolations on $N_\mathrm{test}\approx10^{5}$ regularly positioned test nodes, ${\b x}' \in [0, 1]^2$. The performance of the three interpolation methods is evaluated in Figure~\ref{fig:interpolation}. On the left, we show the interpolated values using $N_{\mathrm{fit}}=384$ fitting points (marked with black crosses).

          In the center plot, we evaluate the relative error of all three interpolation methods as function of the neighbourhood/stencil size, $n$.
          For clarity, black dashed lines indicate the stencil sizes $n=12$, recommended by RBF-FD for a second-order method ($m=2$), and $n=30$, recommended for a fourth-order method ($m=4$) (see Equation~\eqref{eq:stencil_size}). We find that Shepard's interpolation leads to interpolation errors that are almost an order of magnitude larger than the errors of RBF-FD and PU. Increasing the neighbourhood size, $n$, only worsens the accuracy of Shepard's interpolation. \hl{RBF-FD and PU show comparable accuracy, both at second and fourth order, with the error decreasing with increasing monomial order}.

          Similar observations are made by a convergence analysis with respect to $N_{\mathrm{fit}}$ and with recommended stencil sizes $n$, shown in the right plot of Figure~\ref{fig:interpolation}. The number of closest neighbours for Sheppard's interpolation is set to $n=3$, as it yielded the highest accuracy in the centre plot. The black dashed lines and their slopes, $k$, show the observed order of convergence.

          Based on these analyses, we have chosen the RBF-FD approach, as it represents the best trade-off between accuracy and computational complexity. Furthermore this method is inherently present in the solution procedure, which is advantageous in two respects: (i) no additional approximation algorithms need to be implemented and (ii) the approximation error of the interpolated concentration is in the worst case of the same order of magnitude as the approximation of the partial differential operators involved~\cite{le2023guidelines}.

          %   Therefore, Shepard's interpolation method is excluded from further analysis due to its low accuracy. The accuracy of the stable RBF-FD and a more complex PU interpolation is less sensitive to the neighbourhood size $n$ and comparable for all sizes $n$ used. Based on these observations, we decide to use the RBF-FD interpolation method to obtain the solute concentration $u_\delta$ because it has good convergence behaviour, it is stable with respect to the template size and it has a with an accuracy comparable to that of the more complex PU approach and is favourable from the point of view of computational complexity.
          \begin{figure}[h]
              \centering
              \includegraphics[width=\textwidth]{figures/interpolation_2d.jpg}
              \caption{Analysis of interpolation performance on a two-dimensional Sibson's function. The left figure illustrates the interpolated field together with the fitting points marked as black crosses. The center figure shows the interpolation error with respect to the stencil size, $n$, in terms of the relative $\ell_2$ norm. The stencil sizes $n=12$ and $n=30$, recommended for $m=2$ and $m=4$, respectively, are shown with dashed vertical lines. The right figure shows the error with respect to the number of fitting points using recommended stencil sizes and $n=3$ for Sheppard's interpolation. The black dashed lines and their slopes, $k$, indicate the observed order of convergence.}
              \label{fig:interpolation}
          \end{figure}
\end{itemize}

%
%
\subsubsection{Grain envelope reconstruction}
\label{sec:reconstruction}
%After calculating the speed $v$ for each node $\x\ienv$ on the envelope, the nodes are translated to new positions following Equation~\eqref{eq:displacement} (see also line~\ref{alg:new_envelope} of Algorithm~\ref{alg:simulate}). However, the 
The spatial propagation of
%a set of 
the envelope nodes, as the grain grows,
%by a set of displacement vectors 
introduces two difficulties. First,
%if the envelope nodes are simply moved along the vectors perpendicular to the envelope boundary, 
the node spacing increases and the local internodal distance $h$ sooner or later violates the requirement of a quasi-uniform internodal distance for stable meshless approximations~\cite{wendland2004scattered,bayona2010rbf, slak2019generation}. Second, some of the nodes from the interior of the computational domain are eventually engulfed by the growing envelope and thus fall outside the domain. Both problems lead to an unstable solution procedure and must therefore be handled accordingly.

To avoid such behaviour, the entire domain is re-discretized when necessary (see line~\ref{alg:disp} of Algorithm~\ref{alg:simulate}), according to the criterion introduced in Section \ref{sec:discretization}. The first step of the re-discretization is a reconstruction of the envelope (see line~\ref{alg:re-discretize} of Algorithm~\ref{alg:simulate}) using a generalised surface reconstruction algorithm~\cite{surface}. This constructs a parametric representation of the envelope using splines $\gamma$ of the $k$-th degree over the translated nodes. Once the parametric representation of the envelope is obtained, a special surface DIVG algorithm~\cite{duh_surface} is used to populate it with a new set of nodes that are suitable for the RBF-FD approximation method~\cite{slak2019generation}.

The rest of the domain can then be discretized with the general DIVG node positioning algorithm.
%It is worth mentioning, that domain re-discretization is among the computationally most expensive steps in the solution procedure, but nevertheless required to assure accurate simulation of the dendritic growth.
%Readers interested in a detailed description of the surface reconstruction algorithm are to to its original proposal~\cite{surface}, nevertheless, a short description, including the Algorithm~\ref{alg:reconstruction}, is given below.

The surface reconstruction is performed by Algorithm~\ref{alg:reconstruction}, which takes a set of randomly ordered envelope nodes $\Gamma_\mathrm{e}$ about to be parametrized with a Jordan curve $\gamma: [a,b] \rightarrow \R^2$. To obtain the Jordan curve, the nodes are first ordered, therefore, a $k$-d tree with envelope nodes is constructed, which allows us to query for nearest neighbours, obtaining a permutation array, $\sigma$, in the process. To find the appropriate permutation $\sigma$, the list of ordered points is first initialized with an arbitrary starting point $\b x_0$. Its nearest neighbour $\b x_p$ is then obtained using the $k$-d tree and added to the list of ordered points. The remaining nodes are then inductively ordered: Once $\b x_j$ is in the list of ordered points, find its nearest neighbour $\b x _p$. If $\b x_p$ is not in the list of already ordered points, set $\b x_{j+1}$ to $\b x_p$, otherwise find the second (or $n$-th) nearest neighbour that is not yet in the list of ordered points. The process is repeated until all construction points from the envelope are ordered.

\begin{algorithm}
    \caption{Discretized boundary surface reconstruction.}
    \label{alg:reconstruction}
    \vspace{1mm}
    \textbf{Input:} Envelope boundary nodes $\Gamma_{e}$, nodal density function $h:~\Omega\to \R$, parametric spline degree $k$.\\
    \textbf{Output:} New domain discretization $\Omega^\star$. \\

    \begin{algorithmic}[1]

        \Function{discretize\_envelope}{$\Gamma_\mathrm{e}, h, k$}
        \State $\sigma \gets \Call{order\_nodes}{\Gamma_\mathrm{e}}$
        \Comment{Returns permutation of nodes $\sigma$.}
        \State $\gamma \gets \Call{fit\_spline}{\Gamma_\mathrm{e}, \sigma, k}$
        \Comment{Fits spline to ordered points.}
        \State $\Gamma_\mathrm{e}^\star \gets \Call{discretize}{\gamma, h}$
        \Comment{Obtaines new envelope discretization.}

        \State \Return $\Gamma_\mathrm{e}^\star$
        \EndFunction\\

        \Function{re-discretize\_domain}{$\Gamma_\mathrm{e}, h, k$}\label{alg:rediscretize}
        \State $\Gamma_\mathrm{e}^\star \gets \Call{discretize\_envelope}{\Gamma_\mathrm{e}, h, k}$\label{alg:re-discretize-envelope}
        \Comment{Obtaines new envelope discretization.}
        \State $\Omega^\star \gets \Call{discretize}{\Gamma_\mathrm{e}^\star, h}$\label{alg:discretize_rest}
        \Comment{Obtaines new domain discretization.}

        \State \Return $\Omega^\star$
        \EndFunction
    \end{algorithmic}
\end{algorithm}


\hl{The ordered nodes are then used to re-construct the envelope shape by fitting a parametric spline} $\gamma$ \hl{of} $k$\hl{-th degree}. $\gamma$ \hl{is discretized with a given point spacing as the new discretized grain envelope,} $\Gamma_\mathrm{e}^\star$. \hl{Note that regular parametrization of} $\gamma$ \hl{is required to employ the surface DIVG}~\cite{duh_surface}. \hl{The surface DIVG takes a regular parametrization} $\gamma$, \hl{its Jacobian, a nodal spacing function} $h$ \hl{and a set of ``seed parameters'' from parameter space as input. The algorithm then returns a set of regularly distributed nodes on the curve, conforming to the spacing function} $h$. \hl{It is important to note that the node spacing does not take place directly in the target space} $\R^d$. \hl{Instead, the algorithm places parameters in the parametric space. The distance between two parameters} $\xi_1$ \hl{and} $\xi_2$ \hl{is then computed between points} $\gamma(\xi_1)$ \hl{and} $\gamma (\xi_2)$ \hl{and compared to} $h$, \hl{making the parameterization of} $\gamma$ \hl{irrelevant for assuring a good discretization quality as long as the determinant of the Jaccobian matrix is nonzero (see Equation~(2.6) in}~\cite{duh_surface}). For a graphical demonstration of the surface reconstruction algorithm, see Figure~\ref{fig:reconstruction}.

To discretize the rest of the domain (see line \ref{alg:discretize_rest} of Algorithm~\ref{alg:reconstruction}), an \texttt{inside check} algorithm is required to distinguish between the interior and exterior of $\Gamma_\mathrm{e}^\star$. To determine whether a node $\x$ is inside $\Gamma_\mathrm{e}^\star$, a scalar product
\begin{equation}
    \label{eq:insidecheckgamma}
    \left \langle \x - \gamma(t_{\min}), c \b n(t_{\min}) \right \rangle,
\end{equation}
is computed. Here, $\gamma(t_{\min})$ is a node on the envelope closest to $\x$ \hl{and} $\b n(t_{\min})$ \hl{is the normal vector in the same node. The normal vector is computed through a tangent vector} $\b t(t_{\min}) = (t_x, t_y)  \propto {\gamma}'(t_{\min})$ \hl{yielding} $ \b n(t_{\min}) = (-t_y, t_x)$. If the scalar product~\eqref{eq:insidecheckgamma} is negative, $\x$ is in the interior of $\Gamma_\mathrm{e}^\star$, otherwise not. The constant
\begin{equation}
    \label{eq:constant}
    c = -\mathrm{sgn}(\left \langle  \x_\mathrm{int} - \gamma(t_{\min}), \b n (t_{\min})\right \rangle)
\end{equation}
is computed for an arbitrary node $\x_\mathrm{int}$ from the interior and ensures that the normals point outwards. In Equation~\eqref{eq:constant} $t_{\min}$ is determined so that the $\gamma(t_{\min})$ is closest to $\x_\mathrm{int}$.

\emph{Note:} The reconstruction algorithm assumes the nodes from $\Gamma_\mathrm{e}$ must be \emph{dense enough} to adequately describe the curve~\cite{surface}. In our particular case of dendritic growth simulation we must
%take care of this problem by using $h$-refinement with increasing density of nodes towards the envelope, assuring the internodal distance is much smaller than the resolution of the characteristic length of envelope details.
choose a node spacing on and in the vicinity of the envelope, such that the internodal distance is much smaller than the radius of curvature of the envelope.


\begin{figure}
    \centering
    \includegraphics[width=0.8\textwidth]{figures/reconstruction_flower.eps}
    \caption{Example of surface reconstruction accompanied with normal vectors computed from the reconstructed spline $\gamma$ of degree $k\in \left \{1, 2, 3,4\right \}$. For clarity, the encircled area is zoomed in and shown on the right. We also show the normal directions in the right figure.}
    \label{fig:reconstruction}
\end{figure}

%
%
\subsubsection{Choice of the spline degree for accurate envelope reconstruction}
%\label{sec:spline}
The effect of the spline degree is demonstrated in Figure~\ref{fig:reconstruction} for degrees $k\in \left \{1, 2, 3,4\right \}$. As expected, a linear interpolation between two neighbouring nodes ($k=1$) does not yield a satisfying representation of the envelope. %Additionally, the normal vectors (shown in Figure~\ref{fig:reconstruction} on the right) computed from $\gamma(k=1)$ are also inadequate.

Next, a more thorough discussion on the optimal spline degree $k$ for accurate surface reconstruction is given. The reconstruction quality is evaluated on a parametric function
\begin{align}
    \label{eq:parametric_test}
    R(t)    & =\lvert \cos(1.5t) \rvert ^{\sin(3t)} \\
    \b r(t) & =R(t)(\cos(t),\sin(t))
\end{align}
for values $t$ corresponding to the dendrite-tip-like shape (see Figure~\ref{fig:reconstruction_accuracy} left
for clarity).

\begin{figure}[h]
    \centering
    \includegraphics[width=0.9\linewidth]{figures/reconstruction_flower_splines.jpg}
    \caption{Parametric domain used to evaluate the accuracy of surface reconstruction (left) and reconstruction quality analysis (right) in terms of maximum radius error (top right) and maximum normal angle error (bottom right).}
    \label{fig:reconstruction_accuracy}
\end{figure}

A set of equally spaced fit nodes is taken to obtain a parametric representation of the boundary. The internodal distance $h_\mathrm{fit}$ of fit points ranges from $0.1$ to $0.003$, resulting in $124$ and $4094$ fit points respectively. The test points, where the reconstruction quality is evaluated, are generated by discretizing the parametric representation of the boundary $\gamma$ with a uniform internodal distance $h_\mathrm{test}=0.005$, yielding approximately $2450$ test nodes.


%Next, we evaluate the effect of the spline degree,  on the envelope reconstruction quality (line~\ref{alg:re-discretize-envelope} of Algorithm~\ref{alg:reconstruction}). 

The quality of the surface reconstruction is evaluated in terms of (i) the maximum error of the point position in terms of the distance $r=\sqrt{x^2+y^2}$ (top right in Figure~\ref{fig:reconstruction_accuracy}) and (ii) the maximum error of the angle $\vartheta$ of the normal vector $\b n$ (bottom right in Figure~\ref{fig:reconstruction_accuracy}); both within the domain of interest marked in light green in Figure~\ref{fig:reconstruction_accuracy} (left). From the analysis we conclude that the parametric representation of the envelope can be used to obtain an accurate reconstruction of the dendritic grain envelope, and that the spline degree $k$ significantly affects the accuracy of the reconstruction.

Note that a dashed vertical line has been added to the top and bottom right plots in Figure~\ref{fig:reconstruction_accuracy} to mark the internodal distance at which the density of the fit points is approximately equal to the density of the reconstructed nodes, i.e.\ $h_\mathrm{fit} \approx h_\mathrm{test}$. This is also mostly the case in the dendritic growth simulation governed by the GEM.

%In terms of accuracy, we confirm our previous observations that reconstruction with spline degree $k=1$ yields the least accurate results in terms of both distance to the origin $r(t)$ and normal vector angle $\vartheta(t)$. 

From the presented results, it is not possible to objectively deduce which spline degree $k$ yields a sufficiently accurate parametric representation of the dendritic grain envelope. The safest option is to choose the highest proposed spline degree, i.e.\ $k=4$, especially considering that the additional computational cost due to higher spline degrees is marginal.

A more systematic discussion is continued in Section~\ref{sec:istropy}, where the final decision on the spline degree $k=2$ used throughout the rest of this work is made.
%
%

\subsection{Implementation remarks}
The entire MIT solution procedure from Algorithm~\ref{alg:simulate} using meshless methods is implemented in C++ environment. The projects implementation\footnote{Source code is available at \url{https://gitlab.com/e62Lab/public/2022_p_2d_dendritic_growth} under tag \emph{v1.1}.\label{git}} is strongly dependent on our in-house development of a meshless C++ \emph{Medusa library}~\cite{slak2021medusa}.

The code was compiled using \texttt{g++ (GCC) 11.3.0 for Linux} with \texttt{-O3 -DNDEBUG} flags on \texttt{AMD EPYC 7702 64-Core Processor} computer. OpenMP API has been used to run parts of the solution procedure in parallel on shared memory. %due to execution timings, the CPU frequency was fixed to 2.27 GHz with disabled boost functionality and assured CPU affinity using the \texttt{taskset} command. 
Post-processing was done using Python 3.10.6 and Jupyter notebooks, also available in the provided git repository\footref{git}.
%
%

\section{MIT solution procedure verification: Isotropic growth of grain envelope}
\label{sec:istropy}

The goal of this section is analyse how the behaviour of the full MIT procedure depends (i) on the order of the RBF-FD approximation and (ii) on the order of the spline reconstruction of the envelope, and to quantify the errors linked to these methods.

To verify the full MIT solution procedure we propose a simple isotropic growth test, effectively forcing the Equation~\eqref{eq:displacement} to take the following form
\begin{equation}
    \x_i' = \x_i + v(u_{\delta,i}) \b n_i \mathrm{d}t, \quad \forall \x_i \in \Gamma_\mathrm{e},
\end{equation}
and thus discarding the preferred directions of growth. With such setup, the grain envelope is expected to maintain its initial circular shape through all computational time steps and can therefore be used for verification of the method. The test is shown schematically in Figure~\ref{fig:sketch_isotropic}. The computational domain is a circle of diameter $L=20$ with Neumann boundary conditions enforced on the outer (liquid) boundary $\Gamma_\ell$ and a Dirichlet boundary condition of $u=0$ enforced on the growing grain envelope $\Gamma_\mathrm{e}$. At time $t=0$, the envelope is initialized with a circle of radius $r_0 = 0.22239$ and the liquid in the domain $\Omega$ has a uniform initial concentration of $u_0=0.18$.

\begin{figure}[h]
    \centering
    \begin{subfigure}[b]{0.425\textwidth}
        \centering
        \includegraphics[width=\linewidth]{figures/sketch-iso.jpg}
        \caption{Schematic representation of the isotropic problem. In the top right corner a set of black nodes is used to illustrate the \h-refinement towards the envelope.}
        \label{fig:sketch_isotropic}
    \end{subfigure}
    \hfill
    \begin{subfigure}[b]{0.49\textwidth}
        \centering
        \includegraphics[width=\linewidth]{figures/isotropy_envelope_shapes.eps}
        \caption{Isotropic growth time lapse for 5 simulations times $t$ with the total number of time steps written at bottom of each envelope.}
        \label{fig:isotropy}
    \end{subfigure}
    \caption{Presentation of the isotropic growth case.}
    \label{fig:isotropy_presentation}
\end{figure}

\begin{wrapfigure}{r}{0.5\textwidth}
    \vspace{-0.77cm}
    \centering
    \includegraphics[width=0.49\textwidth]{figures/timestep_convergence.eps}
    \caption{Average radius of the isotropic envelope at simulation time $t=4.5$ with respect to time step $\mathrm{d}t$.}
    \label{fig:timestep_conv}
\end{wrapfigure}
In Figure~\ref{fig:isotropy}, a time-lapse of the isotropic envelope calculated with MIT shows the circular envelope expansion. For clarity, a black line is constructed to demonstrate an \emph{exact} circular shape, with the radius equal to the mean distance of the envelope nodes from the grain center.

Before we perform the analysis of MIT spatial discretization error, a scan over the time step size is performed to ensure an appropriate temporal discretization. \hl{The stability of the method in }$h$\hl{-refined node arrangement is limited to the worst case, i.e. to the smallest internodal distance, therefore the optimal approach would be to scale time-step according to the varying }$h$\hl{. In a recent paper}~\cite{Dobravec2023} \hl{authors used quad-tree time step adaptivity to take this into account. In this paper, however, we use a global time step, which we set according to the stability criterion for the smallest internodal distance with additional safety margin. To ensure we indeed use a small enough time step, we also performed numerical analysis presented in} Figure~\ref{fig:timestep_conv}, where the average envelope radius $\overline{r}$ at simulation time $t=4.5$ is shown with respect to the time step $\mathrm{d}t$.
%According to the Courant stability criteria,
Too large time steps ($\mathrm{d}t\ge 6\cdot 10^{-4}$) result in divergent solutions, while time steps $\mathrm{d}t\le 3\cdot 10^{-4}$ give stable solutions for both the second and fourth order discretization approaches. Therefore, we use $dt = 3\cdot 10^{-4}$ in all following discussions.


%First, we will observe discrepancy between expected circular shape and shape we get after different times of MIT simulation. 
Next, Figure~\ref{fig:isotropy_angles} shows the
%difference between the angle of calculated normal $\vartheta (\b n)$ and the angle of the radial vector pointed towards the envelope position $\vartheta (\b x_{\rm env})$ at simulation time $t\approx 11.5$. 
distortion of the calculated normal angle, $\vartheta (\b n)$, as function of the radial angle, $\vartheta (\b x_\mathrm{env})$.
%
The deviations from the ideal circular shape do not significantly depend on the spline degree, $k$, for $k > 1$, while $k=1$ is too low for adequate surface reconstruction. We also observe a significant improvement in MIT accuracy when using a higher order RBF-FD (compare the left and right plots of Figure~\ref{fig:isotropy_angles}, corresponding to the second and fourth order RBF-FD approximation, respectively). The shape deviations are presented in a more quantitative manner in Table~\ref{tab:tabular}, where the extrema of the distortion in the envelope radius, from the mean radius, $\overline{r}$, and the largest distortions of the normal angles, $\vartheta (\b n) - \vartheta (\b x_\mathrm{env})$, are tabulated.

\begin{figure}[h]
    \centering
    \includegraphics[width=0.85\textwidth]{figures/isotropy_growth_angles.eps}
    \caption{Shape distortion of the isotropic envelope: the difference in angle between the computed normal $\vartheta (\b n)$ and the angle of the radial vector pointed towards the envelope position  $\vartheta (\b x_{\rm env})$ at $t\approx 11.5$ using second order RBF-FD (left) and fourth order RBF-FD (right). $k$ is the order of the spline used for envelope reconstruction.}
    \label{fig:isotropy_angles}
\end{figure}

\begin{table}[H]
    \begin{center}
        \begin{tabular}{  l |c c c c c c}
            \toprule
                                             &                 & $\overline{r}$ & $\overline{r} - \min(r)$ & $\max(r) - \overline{r} $ & $\max(\vartheta(\b n)  -\vartheta(\x_\mathrm{env}))$ [$^\circ$] & $\min(\vartheta(\b n)  -\vartheta(\x_\mathrm{env}))$ [$^\circ$] \\ \midrule

            \multirow[0]{4}{*}{\rot{$m= 2$}} & $\gamma(k = 1)$ & $7.3690$       & $0.0340$                 & $0.0357$                  & $2.9411$                                                        & $-3.0012$                                                       \\
                                             & $\gamma(k = 2)$ & $7.3967$       & $0.0285$                 & $0.0203$                  & $3.9000$                                                        & $-4.0700$                                                       \\
                                             & $\gamma(k = 3)$ & $7.3970$       & $0.0225$                 & $0.0301$                  & $2.9738$                                                        & $-4.4241$                                                       \\
                                             & $\gamma(k = 4)$ & $7.3983$       & $0.0263$                 & $0.0238$                  & $2.8899$                                                        & $-3.0776$                                                       \\\midrule
                                             & $\gamma(k = 1)$ & $7.3514$       & $0.0322$                 & $0.0321$                  & $3.2313$                                                        & $-2.8206$                                                       \\
                                             & $\gamma(k = 2)$ & $7.3913$       & $0.0037$                 & $0.0031$                  & $0.3517$                                                        & $-0.2851$                                                       \\
                                             & $\gamma(k = 3)$ & $7.3908$       & $0.0036$                 & $0.0021$                  & $0.2039$                                                        & $-0.2423$                                                       \\
            \multirow[0]{-4}{*}{\rot{$m=4$}} & $\gamma(k = 4)$ & $7.3914$       & $0.0014$                 & $0.0032$                  & $0.2227$                                                        & $-0.3810$                                                       \\
            \bottomrule
        \end{tabular}
    \end{center}
    \caption{Shape distortion from a circular shape at $t=11.5$ depending on the order of the RBF-FD approximation, $m$, and the on order of the splines for surface reconstruction, $k$. The distortion is represented in terms of the largest deviations from the mean radius, $r - \overline{r}$, and the largest distortions of the normal angles, $\vartheta (\b n) - \vartheta (\b x_\mathrm{env})$.}
    \label{tab:tabular}
\end{table}

From the above analysis we can conclude that: (i) splines of order $k > 1$ should be used for envelope reconstruction to achieve good accuracy, (ii) shape distortions depend on the order of the RBF-FD and high-order ($m=4$) is required for high accuracy of the envelope normal direction, while the accuracy of the mean size (radius) is satisfactory even at low RBF-FD orders ($m=2$).
%accurate calculation of the in terms of mean radius $\overline{r}$ there is no obvious advantage in using a high order RBF-FD, especially when considering the computational cost, however, an advantage can be seen in smaller extremal values of normal vector angle errors.

The temporal evolution of the two error metrics ($\vartheta (\b n)$ - $\vartheta (\b x_{\rm env})$ and $\overline{r} \pm [\mathrm{min}(r), \mathrm{max}(r)]$) is assessed in Figure~\ref{fig:isotropy_timelapse}. Except for $k=1$ splines, the error strictly increases with time. It is now even more evident that $k=1$ does not give a sufficiently accurate surface reconstruction. The differences between the second- and fourth-order RBF-FD approximations are relatively small (less than 0.5\% difference in the radius even at the end of the simulation), thus the use of the computationally much more demanding fourth-order method might not be justified.

\begin{figure}[h]
    \centering
    \includegraphics[width=\linewidth]{figures/isotropy_growth_time_evolution.eps}
    \caption{Time evolution of the shape distortion of the isotropic envelope. The top row shows distortion in normal vector angles and the bottom row shows distortion in terms of radius, the left column shows second order and the right column shows fourth order RBF-FD approximation.}
    \label{fig:isotropy_timelapse}
\end{figure}

%\begin{table}[H]
%	\begin{minipage}[b]{0.65\linewidth}
%		\centering
%		\renewcommand{\arraystretch}{1.1}
%		\begin{tabular}{  l |c c c c c c}
%			\toprule
%			&                                 & $\overline{r}$ & $\overline{r} - r_\mathrm{min}$ & $r_\mathrm{max} - \overline{r} $ & $\vartheta(\b n)_\mathrm{max}$ [$^\circ$] & $\vartheta(\b n)_\mathrm{min}$ [$^\circ$] \\ \midrule
%			
%			\multirow[0]{5}{*}{\rot{$m= 2$}} & $\gamma (\b n \propto \nabla) $ & $7.4004$       & $0.0257$                        & $0.0226$                         & $2.6285$                                  & $-4.1683$                                 \\
%			& $\gamma(k = 1)$                 & $7.3690$       & $0.0340$                        & $0.0357$                         & $2.9411$                                  & $-3.0012$                                 \\
%			& $\gamma(k = 2)$                 & $7.3967$       & $0.0285$                        & $0.0203$                         & $3.9000$                                  & $-4.0700$                                 \\
%			& $\gamma(k = 3)$                 & $7.3970$       & $0.0225$                        & $0.0301$                         & $2.9738$                                  & $-4.4241$                                 \\
%			& $\gamma(k = 4)$                 & $7.3983$       & $0.0263$                        & $0.0238$                         & $2.8899$                                  & $-3.0776$                                 \\\midrule
%			& $\gamma (\b n \propto \nabla) $ & $7.3914$       & $0.0051$                        & $0.0035$                         & $0.5215$                                  & $-0.4200$                                 \\
%			& $\gamma(k = 1)$                 & $7.3514$       & $0.0322$                        & $0.0321$                         & $3.2313$                                  & $-2.8206$                                 \\\rowcolor{Gray}
%			\cellcolor{white}                & $\gamma(k = 2)$                 & $7.3913$       & $0.0037$                        & $0.0031$                         & $0.3517$                                  & $-0.2851$                                 \\
%			& $\gamma(k = 3)$                 & $7.3908$       & $0.0036$                        & $0.0021$                         & $0.2039$                                  & $-0.2423$                                 \\
%			\multirow[0]{-5}{*}{\rot{$m=4$}} & $\gamma(k = 4)$                 & $7.3914$       & $0.0014$                        & $0.0032$                         & $0.2227$                                  & $-0.3810$                                 \\
%			\bottomrule
%		\end{tabular}
%		% \caption{Surface reconstruction quality evaluation. Mean circle radius $\overline{r}$ is computed for a set of different spline degrees $k$ and for both normal computation approaches, i.e.\ $\b n \propto {\gamma}''(k)$ and $\b n \propto \nabla u$. Index \emph{err} is used to denote the difference between the two conceptually different approaches, e.g.\ $\overline{r}_\mathrm{err} = \overline{r}_{\b n \propto {\gamma}''(k)} - \overline{r}_{\b n \propto \nabla u}$ and $\vartheta(\b n)_\mathrm{err} = \vartheta(\b n)_{\b n \propto {\gamma}''(k)} - \vartheta(\b n)_{\b n \propto \nabla u}$.}
%		\caption{dt=0.05}
%		\label{tab:isotropy_radius}
%	\end{minipage}\hfill
%	\begin{minipage}[b]{0.33\linewidth}
%		\centering
%		\includegraphics[width=\textwidth]{figures/radiuses_isotropy.eps}
%		\captionof{figure}{Mean radius at selected time step for a set of different spline degrees $k$.}
%		\label{fig:isotropy_radius}
%	\end{minipage}
%\end{table}
%To choose the optimal spline degree, the accuracy of the surface reconstruction is further evaluated in Figure~\ref{fig:isotropy_radius} where the mean circle radius after 36\,520 time steps corresponding to simulation time $t\approx 11.0$ is shown. For reference, the mean radius computed when the normals are proportional to the gradient of solute concentration are added with a dashed horizontal line. Additionally considering the numerical data provided in Table~\ref{tab:isotropy_radius}, it becomes evident that spline degree $k=1$ yields inaccurate results when a full MIT solution procedure is employed. Instead, splines with $k\ge2$ should be used for a quality reconstruction and accurate solution procedure.

%It is worth mentioning that the two conceptually different approaches of computing the normal vectors $\b n$ yield results of similar quality with a comparable error magnitude observed in Figure~\ref{fig:isotropy} (right) and Figure~\ref{fig:isotropy_radius}. Nevertheless, computing the gradient of solute concentration is computationally more demanding than computing the second derivative of the spline $\gamma$. Thus, all normals in the continuation of this work are computed from the constructed parametric representation of dendrite's envelope.
